
Const sReparsePoint = "C:\FastBackMountedVolumes"
Const sEncyptedFile = "C:\credential.txt"
Const iNumberOfMonthToKeepLogs = 1

Const findInstallDir = True
Const sDefaultInstallationDir = "C:\Program Files\Tivoli\TSM\FastBack\shell\"
Const sLogFilesLocation = "C:\FastBackLogs"
Const strBatchPath = "C:\FastBackScripts"
Const sDumpFile = "C:\dump.txt"
Const sCreateRerunSciptsFile = "C:\rerunCreateMountScripts.bat"

Const sMountFile = "Mount"
Const sDismountFile = "Dismount"

Const sRenameVBSFileName = "FastBackRename.vbs"
Const sDeleteVBSFileName = "FastBackDeleteDir.vbs"
Const sPurgeMountLogsVBSFileName = "FastBackPurgeMountLogs.vbs"



'Do Not Change the following consts
Const sBatchFile = ".bat"
Const sLogFile = ".log"


Dim strUID
Dim sUID
Dim strPass
Dim sPass
Dim sAbortOnError
Dim sErrorCode
Dim sSuccessCode
Dim sTapeSoftware
Dim strServer
Dim strDomain
Dim sDomain
Dim strRepType
Dim strRepShareName
Dim strRepFolderName
Dim strErrorCode
Dim strAbortOnError
Dim sMountDir
Dim sWorkingPath

Dim bBreakByServer
Dim bBreakByVolume
Dim bBreakByPolicy

Dim bRemoveDirStructure
Dim bCreateScriptBatch

Dim sInstallationDir
Dim sInstallationVolume


Const ForAppending = 8
Const ForReading = 1
Const ForWriting = 2

strAbortOnError = ""


'init parametetrs
bBreakByServer = False
bBreakByVolume = False
bBreakByPolicy = False
bRemoveDirStructure = False
bCreateScriptBatch = True
bUseUserFromEncFile = False
strRepShareName = ""
strRepFolderName = ""
sWorkingPath = ""
sUID = ""
sPass = ""
sDomain = ""
TapeSoftware = ""
BreakPerServer = ""
BreakPerVolume = ""
BreakPerPolicy = ""


Set Argument = WScript.Arguments

If (Argument.Count > 0) Then

	'Get the values from the HTML
	
	Set colNamedArguments = WScript.Arguments.Named
	strRepType = colNamedArguments.Item("repType")

	If (LCase(strRepType) = "folder") Then
		strRepFolderName = colNamedArguments.Item("folderName")
	End If
	
	If (LCase(strRepType) = "share") Then
		strRepShareName = colNamedArguments.Item("shareName")
	End If

	sUID = colNamedArguments.Item("Username")
	sPass = colNamedArguments.Item("Password")
	sDomain = colNamedArguments.Item("Domain")
	sTapeSoftware = colNamedArguments.Item("TapeSoftware")

	checkTapeSoftware

	sBreakByServer = colNamedArguments.Item("BreakPerServer")
	If (LCase(sBreakByServer) = "true") Then
		bBreakByServer = True
	End If

	sBreakByVolume = colNamedArguments.Item("BreakPerVolume")
	If (LCase(sBreakByVolume) = "true") Then
		bBreakByVolume = True
	End If

	sBreakByPolicy = colNamedArguments.Item("BreakPerPolicy")
	If (LCase(sBreakByPolicy) = "true") Then
			bBreakByPolicy = True
	End If
	
	sRemoveDirStructure = colNamedArguments.Item("RemoveDirStructure")
	If (LCase(sRemoveDirStructure) = "true") Then
		bRemoveDirStructure = True
	End If
	
	'Used for batch only
	bUseUserFromEncFile = colNamedArguments.Item("bUseUserFromEncFile")
	
	sWorkingPath = colNamedArguments.Item("path")
	
Else
	
	'Get the values from the VBS GUI
	
	'getUserParameters
End If


createScripts
Sub createScripts()
	If (sWorkingPath <> "") Then
		createRerunBatchFile
	End If
	
	CreateLogs
	findInstallLocation
	'Create the encrypted credential file  
    	createEncyptedFile
	'Incase we're reruning the scripts from a batch file, we put a "dummy" sUID
	If (bUseUserFromEncFile = true) Then
	    sUID = "UserFromFile"
	End If		
	ShellFXString
		
	CreateBatchFiles
        MsgBox "Finished!", vbOkOnly, "OK"
End Sub


Sub createRerunBatchFile()
	Dim sBatchArguments


	
	sBatchArguments = "/repType:" & strRepType
	If (strRepShareName <> "") Then
		sBatchArguments = sBatchArguments & " /shareName:" & strRepShareName
	End If
	If (strRepFolderName <> "") Then
		sBatchArguments = sBatchArguments & " /folderName:" & strRepFolderName
	End If
	If (sUID <> "") Then
		sBatchArguments = sBatchArguments & " /bUseUserFromEncFile:true"
	End If
	If (sTapeSoftware <> "") Then
		sBatchArguments = sBatchArguments & " /TapeSoftware:" & sTapeSoftware
	End If
	If (bBreakByServer = True) Then
		sBatchArguments = sBatchArguments & " /BreakPerServer:True"
	End If
	If (bBreakByVolume = True) Then
		sBatchArguments = sBatchArguments & " /BreakPerVolume:True"
	End If
	If (bBreakByPolicy = True) Then
		sBatchArguments = sBatchArguments & " /BreakPerPolicy:True"
	End If
	If (bRemoveDirStructure = True) Then
		sBatchArguments = sBatchArguments & " /RemoveDirStructure:True"
	End If
	
		
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	
	Set objScriptBatchFile = objFSO.CreateTextFile(sCreateRerunSciptsFile, ForWriting)
	objScriptBatchFile.WriteLine ("@echo off")
	objScriptBatchFile.WriteLine (vbCrLf)
	objScriptBatchFile.WriteLine (Chr(34) + sWorkingPath + Chr(34) + " " + sBatchArguments)
	
	objScriptBatchFile.Close
	Set objFSO = Nothing
	
	
	

End Sub


Function validateInput()

	If (strRepType = "share" And strRepShareName = "") Then
		' Error
		MsgBox "Repository Share Name is missing", vbOKOnly, "Error"
		WScript.Quit
    	End If
    	
    	If (strRepType = "folder" And strRepFolderName = "") Then
		' Error
		MsgBox "Repository Folder Name is missing", vbOKOnly, "Error"
		WScript.Quit
    	End If
        
    If (sUID <> "" And sDomain = "") Then
		' Error
		MsgBox "Domain Name is missing", vbOKOnly, "Error"
		WScript.Quit
    End If


End Function

' Get the User input using the VBS GUI.
' ***************************************************************************************
' *                                                                                     *
' * This method is not used anymore!!!                                                  *
' *                                                                                     *
' ***************************************************************************************

Sub getUserParameters() 

	'Get the input parameters

	'Repository Type
	strType = "Enter repository type (local or share)"
	strRepType = InputBox(strType, "Repository Type")

	strRepType = Trim(LCase(strRepType))
	If (strRepType <> "share") Then
			strRepType = "local"
	End If

	If (strRepType = "share") Then
		strRep = "Enter the repository share name"
		strRepShareName = InputBox(strRep, "Repository Share Name")
		strRepShareName = Trim(strRepShareName)
		validateInput
	End If


	'User / Password / Domain
	strUID = "Enter your FastBack User ID"
	sUID = InputBox(strUID, "User")

	If sUID <> "" Then

		strPass = "Enter your FastBack Password"
		sPass = InputBox(strPass, "Password")

		strDomain = "Enter the FastBack server domain"
		sDomain = InputBox(strDomain, "Domain")

		validateInput
	Else
		resetUser
	End If
	
	strRemoveDirStructure = "Would you like to remove the directory structure on dismount? (y/n)"
	sRemoveDirStructure = InputBox(strRemoveDirStructure, "Remove Dir. Structure")
	If (LCase(sRemoveDirStructure) = "y") Then
		bRemoveDirStructure = True
	End If


	'Abort On error
	strAbortOnError = "Would you want to abort if one of the mount fails? (y/n)"
	sAbortOnError = InputBox(strAbortOnError, "Abort On Error")

	sAbortOnError = Trim(LCase(sAbortOnError))
	If (sAbortOnError <> "y") Then
			sAbortOnError = "no"
	Else
		'If ((sAbortOnError = "yes") Or (sAbortOnError = "y")) Then
			strTapeSoftware = "Enter the name of your Tape software (backupexec, ultrabac, legato, netbackup)"
		sTapeSoftware = InputBox(strTapeSoftware, "Tape Backup Software")
	End If

	checkTapeSoftware

	strBreakPerServer = "Would you like break the batch file per server? (y/n)"
	sFileterByServer = InputBox(strBreakPerServer, "Break By Sever")
	If (LCase(sFileterByServer) = "y") Then
		bBreakByServer = True
	End If

	strBreakByVolume = "Would you like break the batch file per Volume? (y/n)"
	sBreakByVolume = InputBox(strBreakByVolume, "Break By Volume")
	If (LCase(sBreakByVolume) = "y") Then
		bBreakByVolume = True
	End If

	strBreakPerPolicy = "Would you like break the batch file per Policy? (y/n)"
	sBreakByPolicy = InputBox(strBreakPerPolicy, "Break By Policy")
	If (LCase(sBreakByPolicy) = "y") Then
		bBreakByPolicy = True
	End If
	
	Set fso = CreateObject("Scripting.FileSystemObject")
	sWorkingPath = fso.GetAbsolutePathName("")
	sWorkingPath = sWorkingPath + "\TapeIntegration.vbs"
	Set fso = Nothing

End Sub



Sub checkTapeSoftware()
        sTapeSoftware = Trim(LCase(sTapeSoftware))
        sErrorCode = ""
        sSuccessCode = ""
        sAbortOnError = "no"
        If ((sTapeSoftware = "backupexec")) Then
        	sErrorCode = "0"
        	sSuccessCode = "1"
        	sAbortOnError = "yes"
        Else
        	' ultrabac, netbackup, tsm etc.
        	sAbortOnError = "no"
        End If
End Sub



Sub resetUser()
    sUID = ""
    sPass = ""
    sDomain = ""
End Sub

'Create the log folder
Sub CreateLogs()
Dim objFSO

    Set objFSO = CreateObject("Scripting.FileSystemObject")
    If Not objFSO.FolderExists(sLogFilesLocation) Then
        objFSO.CreateFolder (sLogFilesLocation)
    End If
    
    Set objFSO = Nothing

End Sub


Sub backupPrevDumpFile()

	Set objFSO = CreateObject("Scripting.FileSystemObject")
	If objFSO.FileExists(sDumpFile) Then
		sDateTime = Now()
		'sDateTime = FormatDateTime(Date(),0) + "_" + FormatDateTime(Time(),4)
		sDateTime = Replace(sDateTime, ":", "-")
		sDateTime = Replace(sDateTime, "/", "-")
		sDateTime = Replace(sDateTime, "", "_")
		objFSO.MoveFile sDumpFile, sDumpFile + "_" + sDateTime
	end If
	Set objFSO = Nothing

End Sub


'Create and Run the dump command
Sub ShellFXString()
	Dim WshShell
	Dim encryptedValue
	Dim ret
	Set WshShell = CreateObject("WScript.Shell")

	sReparsePointVolume = getReparsePointVolume
	backupPrevDumpFile
	'encryptedValue = getEncryptedValue
    
    'msgbox  sInstallationVolume & sInstallationDir & " FastBackShell.exe -c mount dump -type local -for TapeBackup -reparse " & sReparsePointVolume & " -file " & sDumpFile & " & EXIT"
    
	If (strRepType = "local") Then
	

		'If (sUID <> "") Then
		ret = WshShell.Run ("%comspec% /k " & sInstallationVolume & " & cd " & sInstallationDir & " & FastBackShell.exe -c mount dump -type local -for TapeBackup -reparse " & sReparsePointVolume & " -file " & sDumpFile & " & EXIT", 2, True)
		'Else
		'   WshShell.Run "%comspec% /k " & sInstallationVolume & " & cd " & sInstallationDir & " & FastBackShell.exe -c mount dump -type local -for TapeBackup -reparse " & sReparsePointVolume & " -file " & sDumpFile & " & EXIT", 2, True
		'End If
	Else If (strRepType = "folder") Then
			ret = WshShell.Run ("%comspec% /k " & sInstallationVolume & " & cd " & sInstallationDir & " & FastBackShell.exe -c mount dump -type share -rep " & strRepFolderName & " -for TapeBackup -reparse " & sReparsePointVolume & " -file " & sDumpFile & " & EXIT", 2, True)
		Else
			If (strRepType = "share") Then
				If (sUID <> "") Then
					ret = WshShell.Run ("%comspec% /k " & sInstallationVolume & " & cd " & sInstallationDir & " & FastBackShell.exe -c mount dump -type share -rep " & Chr(34) & strRepShareName & " user=UserFromFile pass=" & sEncyptedFile & Chr(34) & " -for TapeBackup -reparse " & sReparsePointVolume & " -file " & sDumpFile & " & EXIT", 2, True)
				Else
					ret = WshShell.Run ("%comspec% /k " & sInstallationVolume & " & cd " & sInstallationDir & " & FastBackShell.exe -c mount dump -type share -rep " & strRepShareName & " -for TapeBackup -reparse " & sReparsePointVolume & " -file " & sDumpFile & " & EXIT", 2, True)
				End If
			End If
		End If
	End If
	Set WshShell = Nothing
End Sub


'Get the reparse volume for the dump file
Function getReparsePointVolume()
	Dim reparseVolume
	
	If InStr(sReparsePoint, ":\") > 0 Then
		iEnd = InStr(1, sReparsePoint, ":\") + 2
		reparseVolume = Mid(sReparsePoint, 1, iEnd - 1)
	Else
		reparseVolume = "C:\"
		sReparsePoint = "C:\"
	End If
	
	getReparsePointVolume = reparseVolume
End Function

' ************************************************************
' *                                                          *
' * Will be used only when Xpress Shell does not run on the  *
' * same machine as the Xpress Mount.                        *
' * Currently we don't use it!!!                             *
' *                                                          *
' ************************************************************

Function getEncryptedValue()
	Dim objFSO
	Dim sEncryptedStr
	
	Set objFSO = CreateObject("Scripting.FileSystemObject")

	'Check the encrypted file was created
	If objFSO.FileExists(sEncyptedFile) Then
		'Check that the dump file is not empty
		Set objFile = objFSO.OpenTextFile(sEncyptedFile, ForReading)
		sEncryptedStr = objFile.ReadLine
		objFile.Close
	Else
		bEncFileCreated = False
		MsgBox "The system was unable to find the encrypted file: " & sEncyptedFile & "!", vbOKOnly, "Error"
	End If
	
	set objFSO = Nothing
	getEncryptedValue = sEncryptedStr
	
End Function

Sub findInstallLocation()
	Dim objShell
	Dim strRegVal, strRegPath, strInstallPath
	strRegVal = ""

	If (findInstallDir = True) Then
		strInstallPath = "InstallPath"

		Set objShell = CreateObject("WScript.Shell")

		On Error Resume Next
		strRegPath = "HKLM\SOFTWARE\IBM\FastBack\"
		strRegVal = objShell.RegRead(strRegPath & strInstallPath)
		Err.Clear
		If (strRegVal = "") Then
			strRegPath = "HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\IBM\FastBack\"
			strRegVal = objShell.RegRead(strRegPath & strInstallPath)
			Err.Clear
		End If
		'Msgbox strRegVal, vbokonly, strRegPath
	End If
	
	If InStr(strRegVal <> "") Then
		sInstallationDir = strRegVal + "shell\"
	Else
		sInstallationDir = sDefaultInstallationDir
	End If
	
	If InStr(sInstallationDir, ":\") > 0 Then
		iEnd = InStr(1, sInstallationDir, ":\") + 1
		sInstallationVolume = Mid(sInstallationDir, 1, iEnd - 1)
		'Msgbox sInstallationVolume, vbokonly, sInstallationDir
	End If
end sub

'Create the encrypted file with the user login information
Sub createEncyptedFile()
	Dim WshShell
    Set WshShell = CreateObject("WScript.Shell")
    
	If (sUID <> "") Then
		ret = WshShell.Run ("%comspec% /k " & sInstallationVolume & " & cd " & sInstallationDir & " & FastBackShell.exe -c encrypt -d " & sDomain & " -u " & sUID & " -p " & sPass & " -f " & sEncyptedFile & " & EXIT", 2, True)
	End If
	
	Set WshShell = Nothing
end Sub

'Creates the Mount and Dismount Batch files
Sub CreateBatchFiles()
    Dim objFSO
    Dim objFile
    Dim objMountOutFile
    Dim objDismountOutFile
    Dim sReadLine
    Dim sLabel
    Dim sLngLabel
    Dim sCurrentMountFileName
    Dim sNewMountFileName
    Dim sCurrentDismountFileName
    Dim sNewDismountFileName
    Dim fileName
    Dim strMountLogFile
    Dim strDisountLogFile
    Dim sMountFileName
    Dim sDismountFileName
    Dim sMountPoint
    Dim bDumpFileCreated

	bDumpFileCreated = True
    sCurrentMountFileName = ""

    Set objFSO = CreateObject("Scripting.FileSystemObject")

	
	'Check the dump file was created and that it's not empty
    If objFSO.FileExists(sDumpFile) Then
    	'Check that the dump file is not empty
		Set objFile = objFSO.OpenTextFile(sDumpFile, ForReading)
		sReadLine = objFile.ReadLine
		If (LCase(sReadLine) = "empty dump created") Then
			bDumpFileCreated = False
			MsgBox "Empty Dump file was create. Please check for errors and try again.", vbOKOnly, "Error"
		End If
        objFile.Close
	Else
		bDumpFileCreated = False
		MsgBox "The system was unable to find the dump file: " & sDumpFile & ". No batch files were created!", vbOKOnly, "Error"
	End If
		
	'Continue only if the dump file was created
	If (bDumpFileCreated = True) Then
    
		'move the old scripts to a backup folder / Create the scripts folder if it does not exist
		If objFSO.FolderExists(strBatchPath) Then
	        sDateTime = Now()
			sDateTime = Replace(sDateTime, ":", "-")
			sDateTime = Replace(sDateTime, "/", "-")
			sDateTime = Replace(sDateTime, "", "_")
			backupDir = strBatchPath + "\backup_" & sDateTime
			set scriptsFolder = objFSO.GetFolder(strBatchPath)
			Set FileCount = scriptsFolder.Files
			If (FileCount.Count > 0) Then
				objFSO.CreateFolder (backupDir)
				objFSO.MoveFile strBatchPath +"\*.*" , backupDir +"\"
			End If
        Else
	        objFSO.CreateFolder (strBatchPath)
        End If
        
        'create the scripts from the dump file
        Set objFile = objFSO.OpenTextFile(sDumpFile, ForReading)

        'Creates the VBS rename FILE
        createRenameVBSFile
        'Creates the VBS delete FILE
        createDeleteVBSFile
        createPurgeMountLogsVBSFile
        
        'Loop over all the mount points
        Do While Not objFile.AtEndOfStream
            
            sReadLine = objFile.ReadLine
            
            sReadLine = ReplaceSharePath(sReadLine)
            sReadLine = ParseReparsePoint(sReadLine)

            fileName = buildFileName(sReadLine)
            If (fileName = "") Then
                sMountFileName = sMountFile
                sDismountFileName = sDismountFile
            Else
                sMountFileName = sMountFile & fileName
                sDismountFileName = sDismountFile & fileName
            End If
            
            sNewMountFileName = sMountFileName & sBatchFile
            sNewDismountFileName = sDismountFileName & sBatchFile
            strMountLogFile = Chr(34) & sLogFilesLocation & "\" & sMountFileName & sLogFile & Chr(34)
            strDisountLogFile = Chr(34) & sLogFilesLocation & "\" & sDismountFileName & sLogFile & Chr(34)
            
			If (sCurrentMountFileName <> sNewMountFileName) Then

				'Open the file

				'Existing file
				If objFSO.FileExists(strBatchPath & "\" & sNewMountFileName) Then
					Set objMountOutFile = objFSO.OpenTextFile(strBatchPath & "\" & sNewMountFileName, ForAppending)
					Set objDismountOutFile = objFSO.OpenTextFile(strBatchPath & "\" & sNewDismountFileName, ForAppending)
				Else
					'Create new file
					Set objMountOutFile = objFSO.CreateTextFile(strBatchPath & "\" & sNewMountFileName, ForWriting)
					'Create the Mount file header
					objMountOutFile.WriteLine ("@echo off")
					objMountOutFile.WriteLine ("rem ****** Copyright (C) IBM 2008 ******")
					objMountOutFile.WriteLine ("set dir=" & sInstallationDir)

					'Put the credentials at the top of the file
					If (sUID <> "") Then
						objMountOutFile.WriteLine ("set login=UserFromFile")
						objMountOutFile.WriteLine ("set pass=" & sEncyptedFile)
					End If
                    
                    objMountOutFile.WriteLine (vbCrLf)
                    objMountOutFile.WriteLine (vbCrLf)
                    objMountOutFile.WriteLine ("echo Begin New Mount Log > " & strMountLogFile)
                    
                    Set objDismountOutFile = objFSO.CreateTextFile(strBatchPath & "\" & sNewDismountFileName, ForWriting)
                    'Create the dismount file header
                    objDismountOutFile.WriteLine ("@echo off")
                    objDismountOutFile.WriteLine ("rem ****** Copyright (C) IBM 2008 ******")
                    objDismountOutFile.WriteLine ("set dir=" & sInstallationDir)
                    objDismountOutFile.WriteLine (vbCrLf)
                    objDismountOutFile.WriteLine ("echo Begin New Dismount Log > " & strDisountLogFile)
                    
                End If
                
                sCurrentMountFileName = sNewMountFileName
                sCurrentDismountFileName = sNewDismountFileName
            
            End If
            
            sLabel = ParseLine(sReadLine)
            sLngLabel = ParseDisMount(sReadLine)
            sMountPoint = getMountPoint(sLngLabel)
            
            'Write the data to the Mount file
            
            objMountOutFile.WriteLine (":Drive" & sLabel)
            objMountOutFile.WriteLine ("rem MOUNTING THE " & sLabel & " VOLUME BEFORE THE BACKUP")
            objMountOutFile.WriteLine ("echo>>" & strMountLogFile & "  --------- %date% %time% Start Mount " & sMountPoint & " -----------------")
            objMountOutFile.WriteLine ("echo>>" & strMountLogFile & " -------------------------------------------------------------------")

            
            If (strRepType = "share" and sUID <> "") Then
				'objMountOutFile.WriteLine (setShareCredentials(sReadLine))
				sReadLine = setShareCredentials(sReadLine)
            Else 
            If (strRepType = "folder" and sUID <> "") Then
            	'objMountOutFile.WriteLine (addUserCredentials(sReadLine))
            	sReadLine = addUserCredentials(sReadLine)
            Else
				'Local repository'
					If (sUID <> "") Then
						'Remove the domain'
						'objMountOutFile.WriteLine (RemoveUserDomain(sReadLine))
						sReadLine = RemoveUserDomain(sReadLine)
					Else
						'Remove the login, password and domain'
						'objMountOutFile.WriteLine (RemoveUser(sReadLine))
						sReadLine = RemoveUser(sReadLine)
					End If
				End If
            End If
            objMountOutFile.WriteLine (sReadLine & " >> " & strMountLogFile & " 2>&1")

            If (sAbortOnError = "yes") Then
                objMountOutFile.WriteLine ("if %errorlevel% NEQ 0 goto error_end")
            End If
            objMountOutFile.WriteLine ("echo>>" & strMountLogFile & " ------ %date% %time% End Mount " & sMountPoint & " ----------")
            objMountOutFile.WriteLine ("echo>>" & strMountLogFile & " -------------------------------------------------------")
            objMountOutFile.WriteLine (vbCrLf)
            
            
            'Write the data to the Dismount file
            

            objDismountOutFile.WriteLine ("rem DISMOUNTING THE " & sLabel & " VOLUME AFTER THE BACKUP")
            objDismountOutFile.WriteLine ("echo>>" & strDisountLogFile & " --------- %date% %time% Start Dismount " & sMountPoint & " -----------------")
            objDismountOutFile.WriteLine ("echo>>" & strDisountLogFile & " -------------------------------------------------------------------")

            objDismountOutFile.WriteLine ("""%dir%FastBackShell.exe"" -c mount del " & ParseDisMount(sReadLine) & " -force")

            If (sAbortOnError = "yes") Then
                objDismountOutFile.WriteLine ("if %errorlevel% NEQ 10 goto error_end")
            End If
            
            objDismountOutFile.WriteLine ("echo>>" & strDisountLogFile & " ------ %date% %time% End Dismount " & sMountPoint & " ----------")
            objDismountOutFile.WriteLine ("echo>>" & strDisountLogFile & " -------------------------------------------------------")
            If (bRemoveDirStructure = True) Then
            	objDismountOutFile.WriteLine (strBatchPath & "\" & sDeleteVBSFileName & " " & sMountPoint)
            End If
            objDismountOutFile.WriteLine (vbCrLf)
            	
            

        Loop

        
        
        objMountOutFile.Close
        objDismountOutFile.Close
        objFile.Close
        Set objFSO = Nothing
        Set objMountOutFile = Nothing
        Set objDismountOutFile = Nothing
        Set objFile = Nothing
        
        createFilesFooter
        
        
    End If


End Sub


Function ParseDisMount(sReturn)

    Dim sLine
    Dim iStart
    Dim iEnd
    
    sLine = sReturn
    If InStr(sLine, "-target") > 0 Then
        
        iStart = InStr(sLine, "-target")
        iEnd = InStr(iStart, sLine, "\\") + 3
        sLine = Mid(sLine, iStart, iEnd - iStart)

    End If
ParseDisMount = sLine
End Function


Function getMountPoint(sReturn)

    Dim sMountPoint
    Dim iStart
    Dim iEnd
    
    sMountPoint = sReturn
    If InStr(sMountPoint, "-target") > 0 Then
        
        iStart = InStr(sMountPoint, "-target") + 8
        iEnd = InStr(iStart, sMountPoint, "\\")
        sMountPoint = Mid(sMountPoint, iStart, iEnd - iStart) & Chr(34)
    End If
getMountPoint = sMountPoint
End Function


Function ParseLine(sReturn)
    Dim sLine
    Dim iStart
    Dim iEnd

    sLine = sReturn
    If InStr(sLine, "-target") > 0 Then
    
        iStart = InStr(sLine, "-target")
        iEnd = InStr(iStart, sLine, "Last")
        iEnd = InStr(iStart, sLine, "\\")
        
        sLine = Mid(sLine, iStart, iEnd - iStart)

        sLine = StrReverse(sLine)
        sLine = Left(sLine, InStr(sLine, "\"))
        sLine = StrReverse(sLine)

    End If
ParseLine = sLine
End Function

Function ReplaceSharePath(sReturn)
    Dim sLine
    
    sLine = sReturn
    If (InStr(sReturn, "\share(058)") > 0) Then
        sLine = Replace(sLine, "share(058) (092)(092)", "")
    End If
    If (InStr(sReturn, "(092)(092)") > 0) Then
	sLine = Replace(sLine, "(092)(092)", "")
    End If
    If (InStr(sReturn, "(058)(092)") > 0 ) Then
    	sLine = Replace(sLine, "(058)(092)", "\")
    End If
    sLine = Replace(sLine, "(092)", "\")
	If (InStr(sLine, "\\\") > 0 ) Then	
    	sLine = Replace(sLine, "\\\", "\\")
    End If

ReplaceSharePath = sLine
End Function


'Replace the reparse point with the one set by the user
Function ParseReparsePoint(sReturn)
    Dim sLine
    Dim iStart
    Dim iEnd

	If ((InStr(sReturn, "-target") > 0) AND (Len(sReparsePoint) > 3)) Then
		iStart = InStr(sReturn, "-target")
		iEnd = InStr(iStart, sReturn, ":\") + 2
		iEnd = InStr(iEnd, sReturn, "\")
		sTmp = Mid(sReturn, iStart, iEnd - iStart)
		sLine = Replace(sReturn, sTmp, "-target " & Chr(34) & sReparsePoint)
	Else
		sLine = sReturn
	End If

ParseReparsePoint = sLine
End Function


Function RemoveUser(sReturn)
    Dim sLine
    Dim iStart
    Dim iEnd

    sLine = sReturn
    If InStr(sReturn, "-login") > 0 Then

        iStart = InStr(sReturn, "-login")
        iEnd = InStr(sReturn, "-target")
        sLine = Mid(sReturn, iStart, iEnd - iStart)
        sLine = Replace(sReturn, sLine, "")

    End If
RemoveUser = sLine
End Function

Function RemoveUserDomain(sReturn)
    Dim sLine
    Dim iStart
    Dim iEnd

    sLine = sReturn
    If InStr(sReturn, "-domain") > 0 Then

        iStart = InStr(sReturn, "-domain")
        iEnd = InStr(sReturn, "-target")
        sLine = Mid(sReturn, iStart, iEnd - iStart)
        sLine = Replace(sReturn, sLine, "")

    End If
	RemoveUserDomain = sLine
End Function

Function addUserCredentials(sReturn)
    Dim sLine
    Dim iStart
    Dim iEnd

    sLine = sReturn + " -login %login% -pass %pass%"
    
	addUserCredentials = sLine
End Function

Function setShareCredentials(sReturn)
    Dim sLine
    Dim iStart
    Dim iEnd

    sLine = sReturn
    If InStr(sReturn, "user=") > 0 Then
        iStart = InStr(sReturn, "user=")
        iEnd = InStr(sReturn, "-target")
        sLine = Mid(sReturn, iStart, iEnd - iStart)
        sLine = Replace(sReturn, sLine, "user=%login% pass=%pass%" +Chr(34) + " ")

    End If
	setShareCredentials = sLine
End Function

Function buildFileName(sReturn)
    Dim fileName
    
    fileName = ""
    If (bBreakByServer = True) Then
        fileName = fileName & "_" & getServer(sReturn)
    End If
    
    If (bBreakByVolume = True) Then
        fileName = fileName & "_" & getVolume(sReturn)
    End If
    
    If (bBreakByPolicy = True) Then
        fileName = fileName & "_" & getPolicy(sReturn)
    End If
    
    buildFileName = fileName
End Function

Function getPolicy(sReturn)
Dim sPolicy
    sPolicy = "Unknown_Policy"
    If InStr(sReturn, "-policy") > 0 Then
        iStart = InStr(sReturn, "-policy") + 9
        iEnd = InStr(iStart, sReturn, Chr(34))
        sPolicy = Mid(sReturn, iStart, iEnd - iStart)
    End If

getPolicy = sPolicy
End Function

Function getServer(sReturn)
Dim sServer
    sServer = "Unknown_Server"
    If InStr(sReturn, "-server") > 0 Then
        iStart = InStr(sReturn, "-server") + 9
        iEnd = InStr(iStart, sReturn, Chr(34))
        sServer = Mid(sReturn, iStart, iEnd - iStart)
    End If

getServer = sServer
End Function

Function getVolume(sReturn)
Dim sVolume
    sVolume = "Unknown_Volume"
    If InStr(sReturn, "-volume") > 0 Then
        iStart = InStr(sReturn, "-volume") + 9
        iEnd = InStr(iStart, sReturn, "-date") - 2
        sVolume = Mid(sReturn, iStart, iEnd - iStart)
        If InStr(sVolume, ":") > 0 Then
        	sVolume = Mid (sVolume, 1, 1)
        End If
    End If

getVolume = sVolume
End Function


Sub createFilesFooter()

Dim oFSFile
Dim oFSSubFolder
Dim bCreateFooter
Dim objOutFile
Dim strFile
Dim strLogFile
   
    Set fso = CreateObject("Scripting.FileSystemObject")
    Set Files = fso.GetFolder(strBatchPath).Files
    For Each file In Files
        sFileName = file.Name
        
        If (InStr(sFileName, ".bat") > 0) Then
            strFile = Mid(sFileName, 1, Len(sFileName) - 4) & sLogFile
            strLogFile = Chr(34) & sLogFilesLocation & "\" & strFile & Chr(34)
            If (InStr(sFileName, sMountFile) = 1) Then
                
                ' Mount file
                Set objOutFile = fso.OpenTextFile(strBatchPath & "\" & sFileName, ForAppending)
                
                'Enter the mount file footer
                objOutFile.WriteLine ("rem FINISHED MOUNTING DRIVE VOLUMES")
                objOutFile.WriteLine ("echo>>" & strLogFile & " --------- %date% %time% End Mount Files -----------------")
                objOutFile.WriteLine ("echo>>" & strLogFile & " ---------------------------------------------------------------------")
                objOutFile.WriteLine (strBatchPath & "\" & sRenameVBSFileName & " " & Chr(34) & strFile & Chr(34))
                objOutFile.WriteLine ("EXIT /B " & sSuccessCode)
                objOutFile.WriteLine (vbCrLf)
                objOutFile.WriteLine (":error_end")
                objOutFile.WriteLine ("echo>>" & strLogFile & " could not mount " & sLngLabel & " drive aborting backup")
                objOutFile.WriteLine (strBatchPath & "\" & sRenameVBSFileName & " " & Chr(34) & strFile & Chr(34))
                objOutFile.WriteLine ("EXIT /B " & sErrorCode)
                objOutFile.WriteLine (vbCrLf)
                
                objOutFile.Close
            
            Else    'Dismount file
                If (InStr(sFileName, sDismountFile) = 1) Then
        
                    Set objOutFile = fso.OpenTextFile(strBatchPath & "\" & sFileName, ForAppending)
                    
                    'Enter the mount file footer
                    objOutFile.WriteLine ("goto end" & vbCrLf)
                    objOutFile.WriteLine (vbCrLf)
                    objOutFile.WriteLine (":end")
                    objOutFile.WriteLine ("rem FINISHED DISMOUNTING DRIVE VOLUMES")
                    objOutFile.WriteLine ("echo>>" & strLogFile & " --------- %date% %time% End Dismount Files -----------------")
                    objOutFile.WriteLine ("echo>>" & strLogFile & " ---------------------------------------------------------------------")
                    objOutFile.WriteLine (strBatchPath & "\" & sRenameVBSFileName & " " & Chr(34) & strFile & Chr(34))
                    objOutFile.WriteLine ("EXIT /B " & sSuccessCode)
                    objOutFile.WriteLine (vbCrLf)
                    objOutFile.WriteLine (":error_end")
                    objOutFile.WriteLine ("echo>>" & strLogFile & " could not dismount " & sLngLabel & " drive")
                    objOutFile.WriteLine (strBatchPath & "\" & sRenameVBSFileName & " " & Chr(34) & strFile & Chr(34))
                    objOutFile.WriteLine ("EXIT /B " & sErrorCode)
                    objOutFile.WriteLine (vbCrLf)
                    
                    objOutFile.Close
                End If
                
            End If
        End If
            
    Next

    Set objOutFile = Nothing
    Set Files = Nothing
    Set fso = Nothing
    

End Sub


Sub createRenameVBSFile()
Dim objFSO
Dim objFile

    Set objFSO = CreateObject("Scripting.FileSystemObject")

    Set objFile = objFSO.CreateTextFile(strBatchPath & "\" & sRenameVBSFileName, ForWriting)

    objFile.WriteLine ("Dim objFSO")
    objFile.WriteLine ("Dim sStamp")
    
    objFile.WriteLine ("sFileName = WScript.Arguments.Item(0)")
    
    objFile.WriteLine ("Set objFSO = CreateObject(""Scripting.FileSystemObject"")")
    objFile.WriteLine ("sStamp = Now")
    objFile.WriteLine ("sStamp = Replace(sStamp, "":"", ""-"")")
    objFile.WriteLine ("sStamp = Replace(sStamp, ""/"", ""-"")")
    objFile.WriteLine ("If (InStr(sFileName, "".log"") > 0) Then")
    objFile.WriteLine ("sFileName = Mid(sFileName, 1, Len(sFileName) - 4)")
    objFile.WriteLine ("End If")
    objFile.WriteLine ("objFSO.CopyFile """ & sLogFilesLocation & "\"" & sFileName & "".log"", """ & sLogFilesLocation & "\"" & sFileName & sStamp & "".log""")
    objFile.WriteLine ("Set objFSO = Nothing")
    
    objFile.Close
    Set objFile = Nothing
    Set objFSO = Nothing

End Sub

Sub createDeleteVBSFile()
Dim objFSO
Dim objFile

    Set objFSO = CreateObject("Scripting.FileSystemObject")

    Set objFile = objFSO.CreateTextFile(strBatchPath & "\" & sDeleteVBSFileName, ForWriting)

    objFile.WriteLine ("Dim sPathToDelete")
    objFile.WriteLine ("Set WshShell = CreateObject(""WScript.Shell"")")
    objFile.WriteLine ("")
    objFile.WriteLine ("sPathToDelete = WScript.Arguments.Item(0)")
    objFile.WriteLine ("")
    objFile.WriteLine ("While len(sPathToDelete) > 3")
    objFile.WriteLine ("	WshShell.Run ""%comspec% /c RmDir "" & Chr(34) & sPathToDelete & Chr(34) & "" EXIT"", 2, True")
    objFile.WriteLine ("	On Error Resume Next")
    objFile.WriteLine ("	sPathToDelete = Left(sPathToDelete, InstrRev(sPathToDelete, ""\"") - 1)")
    objFile.WriteLine ("Wend")
    objFile.WriteLine ("Set WSHShell = Nothing")

    objFile.Close
    Set objFile = Nothing
    Set objFSO = Nothing

End Sub

Sub createPurgeMountLogsVBSFile()
Dim objFSO
Dim objFile

	Set objFSO = CreateObject("Scripting.FileSystemObject")
    Set objFile = objFSO.CreateTextFile(strBatchPath & "\" & sPurgeMountLogsVBSFileName, ForWriting)

    objFile.WriteLine ("Set fso = CreateObject(""Scripting.FileSystemObject"")")
	objFile.WriteLine ("Set Files = fso.GetFolder(" & Chr(34) & sLogFilesLocation & Chr(34) & ").Files")

	objFile.WriteLine ("keepUntil = DateAdd(""m"", -" & iNumberOfMonthToKeepLogs &", Date)")
		
	objFile.WriteLine ("For Each file In Files")
	objFile.WriteLine ("	sFileName = file.Name")
	objFile.WriteLine ("	file_date = file.DateCreated")
	objFile.WriteLine ("	If (file_date < keepUntil) Then")
	objFile.WriteLine ("		file.Delete")
	objFile.WriteLine ("	End If")
	objFile.WriteLine ("Next")
		
	objFile.WriteLine ("set Files = Nothing")
	objFile.WriteLine ("set fso = Nothing")
    

    objFile.Close
    Set objFile = Nothing
    Set objFSO = Nothing

End Sub